from lpworkitems import models_roadmap
from utils import unicode_or_None


class CollectorStore(object):

    def __init__(self, store, base_url, error_collector):
        self.store = store
        self.base_url = base_url
        self.error_collector = error_collector

    def _clear_all(self, *find_args):
        self.store.find(*find_args).remove()

    def clear_lanes(self):
        self._clear_all(models_roadmap.Lane)

    def clear_cards(self):
        self._clear_all(models_roadmap.Card)

    def store_lane(self, lane):
        self.store.add(lane)

    def store_card(self, card):
        self.store.add(card)


def get_json_item(data, item_name):
    item = data[item_name]
    if item is not None:
        item = item.strip()
    return unicode_or_None(item)


def lookup_kanban_priority(numeric_priority):
    priority_lookup = {-1: "low",
                        0: "normal",
                        1: "high"}
    assert numeric_priority in priority_lookup, (
        "Priority '%s' is unknown." % numeric_priority)
    return unicode_or_None(priority_lookup[numeric_priority])
