from lpworkitems.collect_roadmap import (
    CollectorStore,
    get_json_item,
    lookup_kanban_priority,
    )
from lpworkitems.error_collector import (
    ErrorCollector,
    )
from lpworkitems.models_roadmap import (
    Card,
    Lane,
    )
from lpworkitems.testing import TestCaseWithFakeLaunchpad


class CollectorTests(TestCaseWithFakeLaunchpad):

    def setUp(self):
        super(CollectorTests, self).setUp()
        self.error_collector = ErrorCollector()
        self.collector = CollectorStore(
            self.store, self.lp, self.error_collector)

    def assertClears(self, cls, fn):
        self.assertTrue(self.store.find(cls).count() > 0)
        fn()
        self.assertEqual(0, self.store.find(cls).count())

    # XXX Add tests for the roadmap classes.


class RoadmapUtilsTests(TestCaseWithFakeLaunchpad):

    def setUp(self):
        super(RoadmapUtilsTests, self).setUp()
        self.json_data = {"data": "Text",
                          "whitespace": " Text  ",
                          "none": None
                          }

    def test_get_json_data_unicode(self):
        item = get_json_item(self.json_data, 'data')
        self.assertEquals(item, u'Text')

    def test_get_json_data_whitespace(self):
        item = get_json_item(self.json_data, 'whitespace')
        self.assertEquals(item, u'Text')

    def test_get_json_data_none(self):
        item = get_json_item(self.json_data, 'none')
        self.assertEquals(item, None)
